package exercises.ex_j;

class Diner {
    private String name;
    private boolean isHungry;

    public Diner(String name) {
        this.name = name;
        isHungry = true;
    }

    public String getName() {
        return name;
    }

    public boolean isHungry() {
        return isHungry;
    }

    public void eatWith(Spoon spoon, Diner spouse) {
        while (isHungry) {
            if (spoon.getOwner() == this) {
                if (spouse.isHungry()) {
                    System.out.println(getName() + ": You eat first my darling " + spouse.getName() + "!");
                    spoon.setOwner(spouse);
                } else {
                    spoon.use();
                    this.isHungry = false;
                }
            }
        }
    }
}
