package exercises.ex_t;

import exercises.Utils;

public class Feeder implements Runnable {
    private final String name;
    private final BowlSemaphore[] bowls;

    public Feeder(String name, BowlSemaphore[] bowls) {
        this.name = name;
        this.bowls = bowls;
    }

    @Override
    public void run() {
        while (true) {
            for (int i = 0; i < 3; i++) {
                BowlSemaphore bowl = bowls[i];
                try {
                    if (!bowl.fill()) {
                        System.out.println(name + " filled bowl " + i);
                        Utils.randomSleep(1000, 3000);
                    }
                } catch (InterruptedException _) {}
            }
        }
    }
}
