package exercises.ex_p_bis;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class ChristmasTreeTester {
    public static void main(String[] args) {
        ChristmasTree tree = new ChristmasTree();

        Light light1 = new Light(Ansi.RED);
        Light light2 = new Light(Ansi.RED);
        Light light3 = new Light(Ansi.GREEN);
        Light light4 = new Light(Ansi.GREEN);
        Light light5 = new Light(Ansi.WHITE);
        Light light6 = new Light(Ansi.WHITE);

        tree.addLight(8, 3, light1);
        tree.addLight(11, 5, light2);
        tree.addLight(13, 6, light3);
        tree.addLight(6, 7, light4);
        tree.addLight(10, 2, light5);
        tree.addLight(12, 8, light6);

        ScheduledExecutorService executor = Executors.newScheduledThreadPool(5);
        Light[] lights = {light1, light2, light3, light4, light5, light6};
        for (int i = 0; i < 6; i++) {
            Light light = lights[i];
            executor.scheduleAtFixedRate(light::toggle, 0, (long) (1000 + Math.random() * 2000), TimeUnit.MILLISECONDS);
        }
    }
}
